Subject: Re: tbench regression on each kernel release from 2.6.22 -> 2.6.28

From: Christoph Lameter <[email-masked]>
Date: Mon, 11 Aug 2008 16:33:43 -0500

David Miller wrote:

> Isn't that when some major scheduler changes went in?  I'm not blaming
> the scheduler, but rather I'm making the point that there are other
> subsystems in the kernel that the networking interacts with that
> influences performance at such a low level.  This includes the memory
> allocator :-)

Right this covers a significant portion of the kernel. SLAB was used since .22
was pretty early for SLUB. And around 2.6.24 we had the merges of the antifrag
logic.

.25 was the point where HR timers came in. By switching off hrtimers I can get
some (minor) portion of performance back. There must be more things in play
though.

Maybe what we are seeing is general bloat in kernel execution paths due to the
growth in complexity?